/*====================================================================================
   This file is part of the TechTools Plugin Development Kit. 
   Copyright (c) 2011 by TechTools  

   You may modify this file and/or create derived works to develop plugins 
   for use with TechTools's DigiView software and capture files obtained from
   TechTools' hardware. Any other use is prohibited.

            email: support@tech-tools.com,  sales@tech-tools.com 
		web: www.tech-tools.com   Voice:972-272-9392  FAX: 972-494-5814
======================================================================================*/


// Fully function plug-in (albeit of limited usefullness). Shows minimal requirements.
#include "../plugin.h"

void OnLoad() {}       // no one-time initialization needed
void SetInitItem(unsigned char ID, unsigned char subID, int value) {} // don't care about globals
void SetCfgItem(unsigned char ID, unsigned char subID, int value) {}  // no custom cfg items to set
void StartOfData() {}  // no start-of-parsing inititalization needed
void EndOfData() {}    // no end-of-parsing finalization needed
void OnUnLoad() {}     // no final cleanup needed

void GetStrList(int ID, vector<string> &strl)
{	switch (ID) 
	{  // 0,1 & 5 (descriptions,cfgitems and lookuptables) return empty lists
	case 2:  strl.push_back("State,YELLOW,BLACK,{}"); break; // field format 0
	case 3:  strl.push_back("STATE"); break;      // use STATE pre-parser
	case 4:  strl.push_back("1");	break;        // require framework version 1 or above
	}
}

void Parse(int64 timestamp, Data64 data)
{  // echo all data events as individual formatted fields
	if ((data.bytes[6] & 0x80) == 0x80)  // is a data event (other events are ignored)
		StartField(timestamp,data,0);  // output it with field format 0
}